package hu.bme.mit.socialnetwork.resources.generator;

import com.google.common.collect.Iterables;
import hu.bme.mit.socialnetwork.resources.GeneratorHelper;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import socialnetwork.Community;
import socialnetwork.Person;
import socialnetwork.Sex;

@SuppressWarnings("all")
public class HTMLReportGenerator {
  public void generate(final Resource res, final GeneratorHelper helper) {
    try {
      TreeIterator<EObject> _allContents = res.getAllContents();
      Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
      Iterable<Community> _filter = Iterables.<Community>filter(_iterable, Community.class);
      for (final Community e : _filter) {
        String _name = e.getName();
        String _plus = (_name + ".html");
        CharSequence _compile = this.compile(e);
        helper.createFile(_plus, _compile);
      }
    } catch (Exception _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public void clean(final Resource res, final GeneratorHelper helper) {
    try {
      TreeIterator<EObject> _allContents = res.getAllContents();
      Iterable<EObject> _iterable = IteratorExtensions.<EObject>toIterable(_allContents);
      Iterable<Community> _filter = Iterables.<Community>filter(_iterable, Community.class);
      for (final Community e : _filter) {
        String _name = e.getName();
        String _plus = (_name + ".html");
        helper.cleanFile(_plus);
      }
    } catch (Exception _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public CharSequence compile(final Community c) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<html>");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("<head>");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("<title>Community ");
    String _name = c.getName();
    _builder.append(_name, "    ");
    _builder.append("</title>\t");
    _builder.newLineIfNotEmpty();
    _builder.append("  ");
    _builder.append("</head>");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("<body>");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("<p>This is the generated webpage of the Community ");
    String _name_1 = c.getName();
    _builder.append(_name_1, "    ");
    _builder.append("</p>");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("<p>The following persons are the members of this community:");
    _builder.newLine();
    _builder.append("      ");
    _builder.append("<ul>");
    _builder.newLine();
    {
      EList<Person> _members = c.getMembers();
      for(final Person p : _members) {
        _builder.append("        ");
        CharSequence _compile = this.compile(p);
        _builder.append(_compile, "        ");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("      ");
    _builder.append("</ul>");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("</p>");
    _builder.newLine();
    _builder.append("  ");
    _builder.append("</body>");
    _builder.newLine();
    _builder.append("</html>\t");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence compile(final Person p) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<li>");
    String _name = p.getName();
    _builder.append(_name, "");
    _builder.append(", ");
    Sex _sex = p.getSex();
    _builder.append(_sex, "");
    _builder.append("</li>");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
}
